// Vector with iterator for all primes in a range
//
// 
#include <cmath>
#include <vector>
#include <algorithm>
#include <iostream>

using namespace std;

typedef unsigned long long int Mi5;

template <typename NumberContainer>
void removeTheNumbers(NumberContainer& Primeans,Mi5 Pristart)
{
    for (auto iter{ Primeans.begin() }; iter != Primeans.end(); )
    {
        if (*iter < Pristart)
        {
            iter = Primeans.erase(iter);
        }
        else
        {
            ++iter;
        }
    }
}

vector<Mi5> Prisieve(Mi5 n, Mi5 Pristart)
{
    vector<bool> prime(n + 1, true);

    prime[0] = false;
    prime[1] = false;
    int m = sqrt(n);
    int NumberPrimes1 = 0;

    for (Mi5 p = 2; p <= m; p++)
    {

        // If prime[p] is not changed, then it
        // be a prime worth including
        if (prime[p])
        {
            // Update all multiples of p
            for (Mi5 i = p * 2; i <= n; i += p)
                prime[i] = false;
        }
    }

    // push all the primes into the vector 
    vector<Mi5> Primeans;
    for (int i = 0; i < n; i++)
        if (prime[i]) {
            Primeans.push_back(i);
        }
    removeTheNumbers(Primeans, Pristart);
    for (auto ip : Primeans) {
        NumberPrimes1 += 1;
       
    }
    cout << "NumberPrimes1 =" << NumberPrimes1 << endl;
    return Primeans;  //Can call "Factor Base Code" Here //
}

int main(void)
{
    Mi5 Pristart = 0;
    Mi5 Priend = 0;
    cout << " Prime Generator with bounds using Sieve of Eratosthenes " << endl;
    cout << "For Primes < 2.2 million " << endl;
    cout << "Enter Lower Prime Bound " << endl;
    cin >> Pristart;
    cout << "Enter Upper Prime Bound " << endl;
    cin >> Priend;
    vector<Mi5> Prians = Prisieve(Priend, Pristart);
    for (auto pip : Prians)
        cout << pip << ' ';
    return 0;
}
